<template>
  <div class="employee-view">
    <b-container fluid class="p-3">
      <div>
        <TableHeader @active="setActiveTab" />
        <Table
          :items="filterItems.items"
          :table-fields="tableFields"
          :active-tab="filterItems.activeTab"
          @getTags="getTags"
          @viewEmployee="onView"
          @editEmployee="onEdit"
          @deactivateEmployee="onDeactivate"
          @activateEmployee="onActivate"
        />
      </div>
    </b-container>
  </div>
</template>

<script lang="ts">
import Vue from 'vue'
import Table from './Table.vue'
import TableHeader from './TableHeader.vue'

export default Vue.extend<any, any, any, any>({
  name: 'EmployeeView',
  components: { TableHeader, Table },
  props: {
    tableFields: {
      type: Array,
      default: () => {}
    },
    items: {
      type: Array,
      default: Array as () => any
    }
  },
  data() {
    return {
      activeTab: ''
    }
  },
  computed: {
    filterItems() {
      let items = []
      if (this.activeTab === 'Active') {
        items = this.items.filter((el: any) => el.isActive === true)
      } else if (this.activeTab === 'Archived') {
        items = this.items.filter((el: any) => el.isActive === false)
      }
      return { items, activeTab: this.activeTab }
    }
  },
  mounted() {
    this.setActiveTab('Active')
  },
  methods: {
    setActiveTab(tab: any) {
      this.activeTab = tab
    },
    onView(name: string, id: any) {
      this.$emit('viewEmployee', name, id)
    },
    onEdit(name: string, id: any) {
      this.$emit('editEmployee', name, id)
    },
    onDeactivate(id: any) {
      this.$emit('deactivateEmployee', id)
    },
    onActivate(id: any) {
      this.$emit('activateEmployee', id)
    },
    getTags(tags: any) {
      return (this.$parent as any).getTags(tags)
    }
  }
})
</script>

<style>
.employee-view {
  width: calc(100% - 250px);
  float: right;
}
</style>
